( ADuCmeta.f for ADuC7020, 09nov05cht )

VOCABULARY META
VOCABULARY TARGET
ONLY FORTH DEFINITIONS
: [FORTH] FORTH ; IMMEDIATE
: [META] META ; IMMEDIATE
: [TARGET] TARGET ; IMMEDIATE
: [hidden] hidden ; IMMEDIATE

HEX
VARIABLE debugging?
( -1 debugging? ! )

: .head ( addr -- addr )
   CR >IN @ 20 WORD COUNT TYPE >IN !
   DUP .
   ;

: cr CR
   debugging? @
   IF .S KEY 0A < ABORT" DONE"
   THEN
   ;

: break CR SWAP .S SWAP
   KEY 0A < ABORT" break "
   ;

: FORTH' ' ;
: >body 5 + ;

( smudge 0 )
' 0 2 - 0FF SWAP C!

( Memory Constants )
$00010000 CONSTANT MININT                 \ bottom of ADuC ram memory 
$00080000 CONSTANT MININT-ROM             \ bottom of ADuC flash memory 
$00080200 CONSTANT USER-ROM               \ bottom of ADuC user area 
$000802A0 CONSTANT CODE_BASE	          \ base of CODE area
8000 CONSTANT IMAGE_SIZE
$4    CONSTANT   CELL_SIZE                     \ size of one cell
$100  CONSTANT   USER_SIZE                     \ user area size in cells
$100  CONSTANT   RS_SIZE                       \ return stack/TIB size
$100  CONSTANT   DS_SIZE                       \ data stack size
$100  CONSTANT   TIB_SIZE                      \ TIB size
$1B00  CONSTANT   INIT_SIZE                    \ initialization RAM area size
$0A   CONSTANT   =BASEE
$80       CONSTANT =IMMEDIATE
$40       CONSTANT =COMPILE-ONLY
$7F7F7F1F CONSTANT =MASK
$EB000000 CONSTANT =CALL

MININT CONSTANT MEM_BASE			\ base of memory
MININT INIT_SIZE + DS_SIZE + CONSTANT =SPP	\ bottom of data stack SP0
=SPP TIB_SIZE + CONSTANT =TIB			\ base of termianl input buffer TIB
=TIB RS_SIZE + CONSTANT =RPP		\ bottom of return stack RP0

$FFFF0000 CONSTANT    MMR_BASE_0         
$0405 CONSTANT    POWKEY1_OFFSET     
$0409 CONSTANT    POWCON_OFFSET      
$040D CONSTANT    POWKEY2_OFFSET     
$12000        CONSTANT    Top_Stack      
$40        CONSTANT    UNDEF_Stack_Size    
$20        CONSTANT    SVC_Stack_Size      
$20        CONSTANT    ABT_Stack_Size      
$80        CONSTANT    FIQ_Stack_Size     
$80        CONSTANT    IRQ_Stack_Size     
$80        CONSTANT    USR_Stack_Size     
0       CONSTANT    PLLCFG_Val     

CREATE ram  
$8000 ALLOT

: reset   ram IMAGE_SIZE 0 FILL ;
: ram@   MININT-ROM - ram +  @ ;
\ : ram!   break MININT-ROM - ram +  ! ;
: ram!   MININT-ROM - ram +  ! ;
: binary 2 BASE ! ;
: four   3 FOR DUP ram@ 9 U.R 4 + NEXT ;
: show ( a)   0F FOR CR  DUP 9 .R SPACE
      four 2 SPACES four NEXT ;
: showram 0 0B FOR show NEXT DROP ;

: dump-ram
   BASE @ binary 0
   1000 FOR AFT
      CR DUP ram@ <# 1F FOR # NEXT #> TYPE
\      CR DUP ram@ 20 U.R 
      1+
   THEN NEXT
   DROP BASE ! CR
   ;

VARIABLE hFile
: write-log-file
   Z" ADuCef.log" 
   $40000000 ( GENERIC_WRITE )
   0 ( share mode )
   0 ( security attribute )
   2 ( CREATE_ALWAYS )
   $80 ( FILE_ATTRIBUTE_NORMAL )
   0 ( hTemplateFile )
   CreateFileA hFile !
   hFile @ 
   ram $4000
   PAD ( lpWrittenBytes )
   0 ( lpOverlapped )
   WriteFile
   IF ELSE ." write error" QUIT THEN
   hFile @ CloseHandle DROP
   ;
   
VARIABLE CHECKSUM
CREATE CRLF 0D C, 0A C, 0 , 0 ,
: FILE_TYPE ( addr # -- )
   hFile @ ROT ROT
   PAD ( lpWrittenBytes )
   0 ( lpOverlapped )
   WriteFile
   IF ELSE ." write error" QUIT THEN
  ;
: FILE_CRLF
  CRLF 2 FILE_TYPE
  ;
: ramCOUNT DUP 1+ SWAP ram + C@ 
  ;
: SEND ( addr # -- )
  $" :0200000280007C" FILE_TYPE
  HEX 
  FOR AFT
    DUP 0F AND
    IF ELSE
      FILE_CRLF 
      DUP FF AND CHECKSUM !
      DUP 100 / CHECKSUM +! 
      10 CHECKSUM +!
      $" :10" FILE_TYPE
      DUP <# # # # # #> FILE_TYPE
      $" 00" FILE_TYPE
    THEN
    ramCOUNT DUP CHECKSUM +!
    <# # # #> FILE_TYPE
    DUP 0F AND
    IF ELSE
      CHECKSUM C@ NEGATE
      <# # # #> FILE_TYPE
    THEN
  THEN NEXT
  DROP
  FILE_CRLF
  $" :00000001FF" FILE_TYPE
  FILE_CRLF
  ;

: write-hex-file
   Z" ADuCef.hex" 
   $40000000 ( GENERIC_WRITE )
   0 ( share mode )
   0 ( security attribute )
   2 ( CREATE_ALWAYS )
   $80 ( FILE_ATTRIBUTE_NORMAL )
   0 ( hTemplateFile )
   CreateFileA hFile !
   0 $4000 SEND
   hFile @ CloseHandle DROP
   ;

ONLY META ALSO DEFINITIONS   
FLOAD ARM7asm.f

: $NEXT ( -- )  anew LP ,BX  ;  
  
CODE_BASE org
ONLY META ALSO TARGET ALSO DEFINITIONS
FLOAD ADuCkernel.f

ONLY TARGET ALSO META ALSO DEFINITIONS

: LITERAL ( n -- )
	anew ['] doLIT 
        >body 
        [FORTH] @ [META] ,BL , 
	; [FORTH] IMMEDIATE [META]

: $TARGET ( a -- )                         \ Compile next word to target dictionary
  NAME? [FORTH] ?DUP [META]
  IF [FORTH] C@ [META] =IMMEDIATE [FORTH] AND [META]
    IF [FORTH] EXECUTE [META] ELSE ,BL THEN EXIT
  THEN
  'NUMBER @EXECUTE
  IF [COMPILE] LITERAL EXIT
  THEN THROW ;

: $NEST 	E9224000 , anew ;	\ [-T] RP, {{ LP }} ,STMFD
: $EXIT 	E8B28000 , anew ;	\ [-T] RP, {{ PC }} ,LDMFD
: EXIT   	$EXIT ; [FORTH] IMMEDIATE [META]

ONLY META ALSO TARGET ALSO DEFINITIONS

CODE doVAR ( -- w )                            \ Pop the return stack to the data stack.
  [-P!] TOS, SP, 4 #            ,STR        \ push TOS
  TOS, LP               ,MOV        \ pop TOS from RS
  $EXIT COMPILE-ONLY 

CODE doCON ( -- w )                            \ Pop the return stack to the data stack.
  [-P!] TOS, SP, 4 #            ,STR        \ push TOS
  [P] TOS, LP              ,LDR        \ pop TOS from RS
  $EXIT COMPILE-ONLY 

CODE UP ( -- w )                            \ Pop the return stack to the data stack.
  [-P!] TOS, SP, 4 #            ,STR        \ push TOS
  TOS, R3               ,MOV        \ pop TOS from RS
  $NEXT 

CODE doUSER ( -- w )                            \ Pop the return stack to the data stack.
  [-P!] TOS, SP, 4 #            ,STR        \ push TOS
  [P] WP, LP              ,LDR        \ pop TOS from RS
  TOS, WP, R3			,ADD
  $EXIT COMPILE-ONLY 

ONLY TARGET ALSO META ALSO DEFINITIONS

: ] 	['] $TARGET 'EVAL [FORTH] ! [META] ; [FORTH] IMMEDIATE [META]

: BEGIN ( -- a )
	begin ; [FORTH] IMMEDIATE [META]
: UNTIL ( a -- )
	[COMPILE] ?branch , ; [FORTH] IMMEDIATE [META]
: AGAIN ( a -- )
	[COMPILE] branch , ; [FORTH] IMMEDIATE [META]
: IF	( -- a )
	[COMPILE] ?branch begin 0 , ;  [FORTH] IMMEDIATE [META]
: SKIP	( -- a )
	[COMPILE] branch begin 0 , ; [FORTH] IMMEDIATE [META]
: THEN	( a -- )
	begin [FORTH] SWAP [META] ram! ; [FORTH] IMMEDIATE [META]
: ELSE	( a1 -- a2 )
	[COMPILE] SKIP [FORTH] SWAP [META] [COMPILE] THEN ; [FORTH] IMMEDIATE [META]
: WHILE	( a1 -- a2 a1 )
	[COMPILE] IF [FORTH] SWAP [META] ; [FORTH] IMMEDIATE [META]
: REPEAT ( a2 a1 -- )
	[COMPILE] AGAIN [COMPILE] THEN ; [FORTH] IMMEDIATE [META]
: AFT 	( a1 -- a2 a3 )
	[FORTH] DROP [META] [COMPILE] SKIP begin [FORTH] SWAP [META] ; [FORTH] IMMEDIATE [META]
: FOR	( -- a )
	[COMPILE] >R begin ; [FORTH] IMMEDIATE [META]
: NEXT	( a -- )
	[COMPILE] next , ; [FORTH] IMMEDIATE [META]

: CREATE	( compile user variable )
	makehead begin .head CONSTANT [FORTH] IMMEDIATE [META]
	$NEST
	['] doVAR >body [FORTH] @ [META] ,BL 
	DOES> anew [FORTH] R> @ [META] ,BL ;

: VARIABLE	( compile user variable )
	makehead begin .head CONSTANT [FORTH] IMMEDIATE [META]
	$NEST
	['] doVAR >body [FORTH] @ [META] ,BL 0 , 
	DOES> anew [FORTH] R> @ [META] ,BL ;

: USER	( n -- n+4 )
	makehead begin .head CONSTANT [FORTH] IMMEDIATE [META]
	$NEST 
	['] doUSER >body [FORTH] @ [META] ,BL
	[FORTH] DUP [META] , 4 [FORTH] + [META]
	DOES> [FORTH] R> @ [META] ,BL ;

: CONSTANT	( compile user variable )
	makehead begin .head CONSTANT [FORTH] IMMEDIATE [META]
	$NEST
	['] doCON >body [FORTH] @ [META] ,BL , 
	DOES> anew [FORTH] R> @ [META] ,BL ;
: '	' >body [FORTH] @ ; [META]

: : 	( compile high level word )
	makehead begin .head [FORTH] CONSTANT IMMEDIATE [META]
	$NEST [COMPILE] ]
	DOES> anew [FORTH] R> @ [META] ,BL ;
[FORTH] : ; 	( terminate high level word )
	$EXIT [COMPILE] [ [FORTH] ; IMMEDIATE [META]


ONLY META ALSO TARGET ALSO DEFINITIONS
FLOAD ADuCeforth.f
FLOAD ADuCscope.f
FLOAD ADuCcompiler.f

( patch user variables )
ONLY TARGET ALSO META ALSO
FLOAD startup.f

$80200 org
0 , 0 , 0 , 0 ,
=SPP         ,  \ (SP0)      Pointer to bottom of the data stack.
=RPP         ,  \ (RP0)      Pointer to bottom of the return stack.
' ?RX        ,  \ ('?KEY)    Execution vector of ?KEY.
' TX!        ,  \ ('EMIT)    Execution vector of EMIT for GBA eForth
' accept     ,  \ ('EXPECT)  Execution vector of EXPECT.
' kTAP       ,  \ ('TAP)     Execution vector of TAP.
' TX!        ,  \ ('ECHO)    Execution vector of ECHO.
' .OK        ,  \ ('PROMPT)  Execution vector of PROMPT.
=BASEE       ,  \ (BASE)     Storage of the radix base for numeric I/O.
0 , 0 , 0 , 0 ,
=TIB         ,  \            Pointer to TIB 
0 ,
' $INTERPRET ,  \ ('EVAL)    Execution vector of EVAL.
' NUMBER?    ,  \ ('NUMBER)  Execution vector of NUMBER?.
0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
MININT   ,  \ (CP)       Point to the top of the code dictionary in RAM.
lastc [FORTH] @ [META] ,  \ (NP)       Point to the bottom of the name dictionary.
lasth [FORTH] @ [META] ,  \ (LAST)     Point to the last name in the name dictionary.
lasth [FORTH] @ [META] ,  \ ('FORTH)     Point to the last name in the FORTH vocabulary.

write-log-file
write-hex-file
